{% set isAllowed = is_granted('ROLE_SERVICE_COMMITTEE') or (publisher.serviceGroup and publisher.serviceGroup.overseer or publisher.serviceGroup and publisher.serviceGroup.assistant) is same as app.user.publisher or (app.user.publisher is same as publisher) %}
{% set isDisabled = isAllowed ? false : true %}
{% extends 'base.html.twig' %}

{% block header_title %}
    {{ publisher.fullName }}
    {% if publisher.isElder %}
        <span class="badge bg-primary">Ancien</span>
    {% endif %}
    {% if publisher.isServant %}
        <span class="badge bg-primary">Assitant</span>
    {% endif %}
    {% if publisher.isRegularPioneer %}
        <span class="badge bg-secondary">Pionnier permanent</span>
    {% endif %}
{% endblock %}

{% block header_subtitle %}
    <div class="serviceGroup">
        {% if publisher.serviceGroup %}
            <a href="{{ path('app_fieldservice_servicegroup_show', {'id': publisher.serviceGroup.id}) }}">Groupe {{ publisher.serviceGroup.name }}</a>
        {% else %}
            <div class="alert alert-pro alert-info">{{ publisher.firstName }} n'a pas été attribué à un groupe de prédication</div>
        {% endif %}
    </div>
{% endblock %}

{% block body %}
    <div class="col-12">
        <div class="row mb-2">
            {% for message in app.flashes('success') %}
                <div class="alert alert-fill alert-icon alert-success alert-dismissible">
                    <em class="icon ni ni-check-circle-fill"></em>
                    {{ message }}
                </div>
            {% endfor %}
        </div>



        <div class="row gy-4">
            <div class="col-lg-12">
              <div id="accordion" class="accordion">
                <div class="accordion-item">
                  <a href="#" class="accordion-head" data-bs-toggle="collapse" data-bs-target="#accordion-item-2-1">
                    <h6 class="card-title">
                      Historique des territoires
                    </h6>
                    <span class="accordion-icon"></span>
                  </a>
                  <div class="accordion-body collapse show" id="accordion-item-2-1" data-bs-parent="#accordion-2">
                    <div class="accordion-inner">
                      {% if histories is not empty %}
                      <div class="nk-tb-list nk-tb-orders">
                        <div class="nk-tb-item nk-tb-head">
                          <div class="nk-tb-col tb-col"><span>#</span></div>
                          <div class="nk-tb-col"><span>Sortie</span></div>
                          <div class="nk-tb-col"><span>Entrée</span></div>
                          <div class="nk-tb-col"><span>Suivi par</span></div>
                          <div class="nk-tb-col tb-col"><span></span></div>
                        </div>

                        {% for history in histories %}
                          <div class="nk-tb-item">
                            <div class="nk-tb-col">
                              <div class="user-card">
                                <div class="user-name">
                                  <span class="tb-lead"><a href="{{ path('app_territory_show', {'territory': history.territory.id}) }}">{{ history.territory.area.title }} {{ history.territory.title }}</a></span>
                                </div>
                              </div>
                            </div>
                            <div class="nk-tb-col tb-col">
                              {% if history.outDate|territoryDateValidation('4 months')|date('U') < "now"|date('U') and history.inDate is null %}
                                <span class="badge badge-dot bg-danger">{{ history.outDate|date('d/m/y') }}</span>
                              {% else %}
                                <span class="badge badge-dot bg-secondary">{{ history.outDate|date('d/m/y') }}</span>
                              {% endif %}

                            </div>
                            <div class="nk-tb-col tb-col">
                              {% if history.inDate is not null %}
                                {% if history.inDate|territoryDateValidation('6 months')|date('U') < "now"|date('U') %}
                                  <span class="badge badge-dot bg-success">{{ history.inDate|date('d/m/y') }}</span>
                                {% else %}
                                  <span class="badge badge-dot bg-secondary">{{ history.inDate|date('d/m/y') }}</span>
                                {% endif %}
                              {% endif %}
                            </div>

                            <div class="nk-tb-col tb-col">
                              {{ history.createdBy.fullName }}
                            </div>

                            <div class="nk-tb-col nk-tb-col-action">
                              <div class="dropdown">
                                <a class="text-soft dropdown-toggle btn btn-icon btn-trigger" data-bs-toggle="dropdown"><em class="icon ni ni-more-h"></em></a>
                                <div class="dropdown-menu dropdown-menu-end dropdown-menu-xs">
                                  <ul class="link-list-plain">
                                    <li><a href="{{ path('app_territory_show', {'territory': history.territory.id}) }}">Voir territoire</a></li>
                                    <li><a href="{{ path('app_territory_history_edit', {'history': history.id}) }}">Modifier</a></li>
                                    {% if is_granted('ROLE_ADMIN') is same as true %}
                                      <li><a href="{{ path('app_territory_history_remove', {'history': history.id}) }}">Supprimer</a></li>
                                    {% endif %}
                                  </ul>
                                </div>
                              </div>
                            </div>
                          </div>
                        {% endfor %}
                      </div>
                      {% else %}
                        <div class="alert alert-pro alert-info">Aucun territoire dans l'historique</div>
                      {% endif %}
                    </div>
                  </div>
                </div>
              </div>
            </div>
        </div>


        {% if isAllowed and weekends is not empty %}
            <div class="row mt-4">
                <div class="col-lg-5">
                  <div id="accordion-public-talk" class="accordion">
                    <div class="accordion-item">
                      <a href="#" class="accordion-head" data-bs-toggle="collapse" data-bs-target="#accordion-item-public-talk-1">
                        <h6 class="title">
                          Discours présentés dans l'assemblée locale
                        </h6>
                        <span class="accordion-icon"></span>
                      </a>
                      <div class="accordion-body collapse show" id="accordion-item-public-talk-1" data-bs-parent="#accordion-public-talk">
                        <div class="accordion-inner">
                          <div class="nk-tb-list nk-tb-orders">
                            <div class="nk-tb-item nk-tb-head">
                              <div class="nk-tb-col tb-col"><span>#</span></div>
                              <div class="nk-tb-col"><span>Theme</span></div>
                              <div class="nk-tb-col"><span>Date</span></div>
                              <div class="nk-tb-col tb-col"><span></span></div>
                            </div>

                            {% for weekend in weekends %}
                              <div class="nk-tb-item">
                                <div class="nk-tb-col">
                                  <div class="user-card">
                                    <div class="user-name">
                                      {% if weekend.speech %}
                                        <span class="tb-lead"><a href="#">{{ weekend.speech.number }}</a></span>
                                      {% endif %}
                                    </div>
                                  </div>
                                </div>
                                <div class="nk-tb-col tb-col">
                                  {% if weekend.speech %}
                                    <span><a href="#">{{ weekend.speech.title }}</a></span>
                                  {% else %}
                                    <span><a href="#">{{ weekend.category.name }}</a></span>
                                  {% endif %}

                                </div>
                                <div class="nk-tb-col tb-col">
                                  <span><a href="{{ path('app_meeting_weekend_program_show', {'id': weekend.program.id}) }}" title="Voir le programme">{{ weekend.date|date('d/m/y') }}</a></span>
                                </div>

                                <div class="nk-tb-col nk-tb-col-action">
                                  <div class="dropdown">
                                    <a class="text-soft dropdown-toggle btn btn-icon btn-trigger" data-bs-toggle="dropdown"><em class="icon ni ni-more-h"></em></a>
                                    <div class="dropdown-menu dropdown-menu-end dropdown-menu-xs">
                                      <ul class="link-list-plain">

                                      </ul>
                                    </div>
                                  </div>
                                </div>
                              </div>
                            {% endfor %}
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
            </div>
        {% endif %}

        <div class="row">
            <div class="col-lg-6 mt-4">
                <div id="accordion" class="accordion">
                    <div class="accordion-item">
                        <a href="#" class="accordion-head" data-bs-toggle="collapse" data-bs-target="#accordion-item-1">
                            <h6 class="title"><em class="icon ni ni-user-add me-1"></em>Données personnelles / changement de groupe</h6>
                            <span class="accordion-icon"></span>
                        </a>
                        <div class="accordion-body collapse" id="accordion-item-1" data-bs-parent="#accordion">
                            <div class="accordion-inner">
                                <form action="{{ path('app_publisher_show', {'id': publisher.id}) }}" method="post">
                                    <div class="row gy-2">
                                        <div class="col-md-6">
                                            <div class="form-group">
                                                {{ form_label(form.firstName) }}
                                                {{ form_widget(form.firstName, {'attr': {'disabled': isDisabled}}) }}
                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <div class="form-group">
                                                {{ form_label(form.lastName) }}
                                                {{ form_widget(form.lastName, {'attr': {'disabled': isDisabled}}) }}
                                            </div>
                                        </div>
                                        <div class="col-md-12">
                                            <div class="form-group">
                                                {{ form_label(form.serviceGroup) }}
                                                {{ form_widget(form.serviceGroup, {'attr': {'disabled': isDisabled}}) }}
                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <div class="form-group">
                                                {{ form_label(form.isElder) }}
                                                {{ form_widget(form.isElder, {'attr': {'disabled': isDisabled}}) }}
                                                {{ form_label(form.isServant) }}
                                                {{ form_widget(form.isServant, {'attr': {'disabled': isDisabled}}) }}
                                                {{ form_label(form.isRegularPioneer) }}
                                                {{ form_widget(form.isRegularPioneer, {'attr': {'disabled': isDisabled}}) }}
                                            </div>
                                        </div>
                                        <div class="col-md-4">
                                            <div class="form-group">
                                                {{ form_label(form.gender) }}
                                                {{ form_widget(form.gender, {'attr': {'disabled': isDisabled}}) }}
                                            </div>
                                        </div>
                                        <div class="row gy-2">
                                            <div class="col-md-6">
                                                {% if isAllowed %}
                                                    <div class="form-group">
                                                        {{ form_widget(form._token) }}
                                                        <button class="btn btn-success">Modifier</button>
                                                    </div>
                                                {% endif %}

                                            </div>
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                    {% if isAllowed  %}
                        <div class="accordion-item">
                            <a href="#" class="accordion-head" data-bs-toggle="collapse" data-bs-target="#accordion-item-3">
                                <h6 class="title"><em class="icon ni ni-trash-alt me-2"></em>Suppression</h6>
                                <span class="accordion-icon"></span>
                            </a>
                            <div class="accordion-body collapse" id="accordion-item-3" data-bs-parent="#accordion">
                                <div class="accordion-inner">
                                    <a href="#" class="btn btn-danger" id="removePublisherBtn">Supprimer défintivement</a>
                                </div>
                            </div>
                        </div>
                    {% endif %}

                </div>
            </div>
        </div>
    </div>
{% endblock %}

{% block javascripts %}
    <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.29.4/moment-with-locales.min.js"></script>
    <script>
        const $removePublisherBtn = document.getElementById('removePublisherBtn');
        $removePublisherBtn.addEventListener('click', function (e) {
            e.preventDefault();
            if (confirm('Souhaites-tu supprimer définitivement ce proclamateur de ton assemblée ?')) {
                fetch("{{ path('app_publisher_delete', {'id': publisher.id}) }}", {
                    method: 'DELETE'
                }).then(function(response) {
                    return window.location = "{{ path('app_publisher_list') }}"
                })
            }
        })

        moment.locale('fr');
        const ctx = document.getElementById('filledLineChart');
        const $compilations = $('#filledLineChart').data('compilations')

        const dataTimes = [];
        const dataDates = [];
        const dataColors = [];
        $compilations.forEach((comp) => {
            let date = new Date(comp.date);
            dataTimes.push(comp.times);
            dataDates.push(moment.utc(date).format('MMMM Y'))
            dataColors.push('rgba(215,220,255,0.5)');
        })

        const data = {
            labels: dataDates,
            datasets: [{
                label: 'Moyenne d\'heures par mois',
                data: dataTimes,
                backgroundColor: 'rgba(215,220,255,0.5)',
                borderColor: 'rgba(28,112,227,0.89)',
                borderWidth: 1
            }]
        };

        new Chart(ctx, {
            type: 'line',
            data: data,
            options: {
                scales: {
                    yAxes: [{
                        ticks: {
                            beginAtZero: true
                        }
                    }]
                }
            }
        });
    </script>
{% endblock %}
